n, m, k = map(int, input().split())

graph = [[] for _ in range(n + 1)]
for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

guards = []
for _ in range(k):
    p, h = map(int, input().split())
    guards.append((p, h))

protected_stores = set()

def bfs(start, max_distance):
    queue = [(start, 0)]
    visited = [False] * (n + 1)

    while queue:
        current_store, distance = queue.pop()
        if distance > max_distance:
            break
        protected_stores.add(current_store)

        for neighbor in graph[current_store]:
            if not visited[neighbor]:
                visited[neighbor] = True
                queue.append((neighbor, distance + 1))

for p, h in guards:
    bfs(p, h)

protected_stores = sorted(protected_stores)
print(len(protected_stores))
if protected_stores:
    print(' '.join(map(str, protected_stores)))
else:
    print()
