from collections import deque, defaultdict

n, m, k = map(int, input().split())

graph = defaultdict(list)
for _ in range(m):
    a, b = map(int, input().split())
    graph[a].append(b)
    graph[b].append(a)

guards = []
for _ in range(k):
    p, h = map(int, input().split())
    guards.append((p, h))

protected_stores = set()


def bfs(start, max_distance):
    queue = deque([(start, 0)])
    visited = set()
    visited.add(start)

    while queue:
        current_store, distance = queue.popleft()

        if distance > max_distance:
            break
        protected_stores.add(current_store)

        for neighbor in graph[current_store]:
            if neighbor not in visited:
                visited.add(neighbor)
                queue.append((neighbor, distance + 1))


for p, h in guards:
    bfs(p, h)

protected_stores = sorted(protected_stores)
print(len(protected_stores))
if protected_stores:
    print(' '.join(map(str, protected_stores)))
else:
    print()
