import math

def distance(x1, y1, x2, y2):
    return math.sqrt((x1 - x2) ** 2 + (y1 - y2) ** 2)


def tsp(n, points):
    dp = [[math.inf] * n for _ in range(1 << n)]

    for i in range(n):
        dp[1 << i][i] = 0

    for mask in range(1 << n):
        for i in range(n):
            if mask & (1 << i):
                for j in range(n):
                    if not (mask & (1 << j)):
                        new_mask = mask | (1 << j)
                        dp[new_mask][j] = min(dp[new_mask][j],
                                              dp[mask][i] + distance(points[i][0], points[i][1], points[j][0],
                                                                     points[j][1]))

    min_path_length = math.inf
    for i in range(n):
        min_path_length = min(min_path_length, dp[(1 << n) - 1][i])

    return min_path_length


n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]

result = tsp(n, points)
print(f"{result:.12f}")
