import math

def euclidean_distance(x1, y1, x2, y2):
    return math.sqrt((x2 - x1)**2 + (y2 - y1)**2)

def tsp(n, coordinates):
    dp = [[float('inf')] * n for _ in range(1 << n)]
    for i in range(n):
        dp[1 << i][i] = 0

    for mask in range(1 << n):
        for i in range(n):
            if (mask & (1 << i)) == 0:
                continue
            for j in range(n):
                if (mask & (1 << j)) != 0 or i == j:
                    continue
                new_mask = mask | (1 << j)
                dp[new_mask][j] = min(dp[new_mask][j], dp[mask][i] + euclidean_distance(coordinates[i][0], coordinates[i][1], coordinates[j][0], coordinates[j][1]))

    min_path = float('inf')
    final_mask = (1 << n) - 1
    for i in range(n):
        min_path = min(min_path, dp[final_mask][i] + euclidean_distance(coordinates[i][0], coordinates[i][1], coordinates[0][0], coordinates[0][1]))

    return min_path

n = int(input())
coordinates = [tuple(map(int, input().split())) for _ in range(n)]

result = tsp(n, coordinates)

print(f"{result:.12f}")
